#
# Cookbook Name:: bjn_sod
# Recipe:: default
#
# Copyright (C) 2015 Blue Jeans Network
#

sod = materialize node['sod']

reify :gem_package, sod['gem'], [
  [ :restart, 'service[sod]' ]
]

reify :group, sod['group']

reify :user, sod['user']

%w[ database log ].each do |d|
  next unless sod['opts'][d]

  file sod['opts'][d] do
    owner sod['user']['name']
    group sod['group']['name']
    action :create_if_missing
  end
end

opts = sod['opts'].map do |k, v|
  "--#{k} '#{v}'"
end.join(' ')

template '/etc/init/sod.conf' do
  source 'sod.conf.erb'
  owner 'root'
  group 'root'
  mode '0644'
  variables sod: sod, opts: opts
  notifies :restart, 'service[sod]', :delayed
end

service 'sod' do
  provider Chef::Provider::Service::Upstart
  supports restart: true, reload: true, status: true
  action [ :enable, :start ]
end